function [M_svm,V_svm,M_pw,V_pw]=CV_LND_spanno(name,EN,ErrType,bias,nd)

%[M_svm,V_svm,M_knn,V_knn]=CV_LND_spanno(name,EN,ErrType,bias,nd) 
% Run 5 fold cross validation and report test error of both the final classifier SVM and PW where labels are corrected by LND_spanno
%
%Input : name = string containing folder name of data.
%        EN= 10*percentage of induced label error in data set for most data set it is 1 only for Mushrooms,Svmguide1 and Covertype it can be 0.1,0.2,0.5,1 or 2.
%        ErrType = Type of induced error 
%		'M'=Boundary noise
%               'WC'=Adversarial noise
%		'H'=Biased annotator noise
%        bias= 	1 : Considering induced error in one class only
%	        2 : Considering induced error in both the classes
%	 nd= Level about approximation
%
%Output: M_svm : Average (of 10 run) test error using SVM as final classifier
%	 V_svm : Variance (of 10 run) of  test error using SVM as final classifier
%	 M_knn : Average (of 10 run) test error using PW as final classifier
%        V_knn : Variance (of 10 run) of  test error using PW as final classifier

    

system(['mkdir ../Data/',name,'/CV']);
Data=['../Data/',name,'/',name];
load([Data,'_Parameters.mat']);
KernelType_p ='Gauss';
KernelType ='Gauss';
if bias>2 & bias<1
    disp('bias= 1 (Noisy in one class)or 2(Noise in both the classes)')
end
if strcmp(ErrType,'M') ==0 & strcmp(ErrType,'H')==0 & strcmp(ErrType,'WC')==0
help CV_LND_SLP;
return
end

if (strcmp(name,'WDBC') | strcmp(name,'Adult') | strcmp(name,'Fourclass')| strcmp(name,'Australian') | strcmp(name,'Heart') )
if EN ~=1
help CV_LND_spanno;
return
end
elseif (strcmp(name,'Mushrooms') | strcmp(name,'Svmguide1') | strcmp(name,'Covertype') )
if (EN == 0.1 |EN ==0.2 | EN==0.5 | EN==1 |EN==2)
else
help CV_LND_spanno;
end
else
help CV_LND_spanno;
end


if strcmp(KernelType,'Gauss')
CK=[0.1 1 10 100 1000];
CK2=[ 0.2 1 5];
CSVM=G.CSVM;
CSVM2=G.CSVM2;
SKNN=G.SKnn; %iconfirm
KSVM=G.KSVM; %comfirm;
SP=[0:0.05:0.45];
else
CK=[0.1 1 10 100 1000];
CK2=[0.2 1  5];
CSVM=L.CSVM;
CSVM2=L.CSVM2;
SKNN=L.SKnn; %iconfirm
KSVM=L.KSVM; %comfirm;
SP=[0:0.05:0.45];
end
k=1;
for i=1:1:length(SP)
for j=1:1:length(SP)
kList(k,1:2)=[SP(i),SP(j)];
k=k+1;
end
end


Data=['../Data/',name,'/CV/',name];

ErrT=[ErrType,num2str(bias)];


cs=CSVM;
cs2=CSVM2;
ks=KSVM;



str=[Data,num2str(EN),'_lndspanno',num2str(nd),'_cv_tr_',ErrT,'_err.mat'];
if exist(str, 'file') == 2
load(str);
else
ER=[]
end

for s_count=[size(ER,1)+1:1:10]
%PerN=2*s_count

for k_count=1:1:length(SKNN)
kappa=SKNN(k_count);
cs2=1;

 [ER(s_count,k_count,:,:,:,:),ERknn(s_count,k_count,:),P(s_count,k_count,:),R(s_count,k_count,:),F1(s_count,k_count,:),F(s_count,k_count,:),Con(s_count,k_count,:,:,:,:),E(s_count,k_count,:,:,:,:,:,:),Eknn(s_count,k_count,:,:,:),Output(s_count,k_count).O]=Train_lndspanno_cv(name,EN,KernelType_p,KernelType,ErrT,cs,cs2,ks,kList,kappa,s_count,nd);
end

str=[Data,num2str(EN),'_lndspanno',num2str(nd),'_cv_tr_',ErrT,'_err.mat'];
save(str,'ER','P','R','F1','F','ERknn','kList','Con','E','Eknn','Output','cs','cs2','ks');
end



% testing svm

ERpknn=ERknn;
ERp=ER;
clear ER,ERknn,P,R,F1,F,kList,Output;

str=[Data,num2str(EN),'_LndSpanno_',num2str(nd),'_',ErrT,'_err_svm.mat'];
if exist(str, 'file') == 2
load(str);
else
tER=[]
end

for s_count=[size(tER,1)+1:1:10]

size(ERpknn);
Epknn=ERp(s_count,:,:,:,:,:);
[t0,t1,t2,t3,t4,t5,t6]=ind2sub(size(Epknn),find(Epknn==min(Epknn(:))));

Ep=squeeze(ERp(s_count,t1(1),:,:,:,:));
[t2,t3,t5]=ind2sub(size(Ep),find(Ep==min(Ep(:))));

if (length(CSVM)>1)
        cs=t3(1);
        cs2=1;
        if strcmp(KernelType,'Gauss')
                ks=t5(1);
        else
                ks=1;
        end
else
        cs=1;
        cs2=1;
        if strcmp(KernelType,'Gauss')
                ks=t3(1);
        else
                ks=1;
        end
end

Par(s_count,:)=[t1(1),cs,cs2,t2(1),ks];


tER(s_count,:)=squeeze(E(s_count,t1(1),t2(1),:,6,cs,1,ks));

tPrecision(s_count,:)=squeeze(Con(s_count,t1(1),t2(1),:,6,5));
tRecall(s_count,:)=squeeze(Con(s_count,t1(1),t2(1),:,6,6));
tF1(s_count,:)=squeeze(Con(s_count,t1(1),t2(1),:,6,7));
tPrecisionC(s_count,:)=squeeze(Con(s_count,t1(1),t2(1),:,6,8));
tRecallC(s_count,:)=squeeze(Con(s_count,t1(1),t2(1),:,6,9));
tF1C(s_count,:)=squeeze(Con(s_count,t1(1),t2(1),:,6,10));
er=squeeze(tER(s_count,:));
M_svm(s_count)=mean(er);
V_svm(s_count)=std(er);


end


strf=[Data,num2str(EN),'_LndSpanno_',num2str(nd),'_',ErrT,'_err_svm.mat'];
save(strf,'tER','tPrecision','tRecall','tF1','tPrecisionC','tRecallC','tF1C','Par','M_svm','V_svm');


clear tER tPrecision tRecall tF1 tPrecisionC tRecallC tF1C Par;
% testing knn

str=[Data,num2str(EN),'_LndSpanno_',num2str(nd),'_',ErrT,'_err_pw.mat'];
if exist(str, 'file') == 2
load(str);
else
tER=[]
end

for s_count=[size(tER,1)+1:1:10]

Epknn=ERpknn(s_count,:,:);
[t0,t1,t2]=ind2sub(size(Epknn),find(Epknn==min(Epknn(:))));
kappa=SKNN(t1(1));
Ek=squeeze(ERpknn(s_count,t1(1),:));
t2=find(Ek==min(Ek(:)));
kl=kList(t2(1),:);
Par(s_count,:)=[kappa,kl];

tER(s_count,:)=squeeze(Eknn(s_count,t1(1),t2(1),:,6));

tPrecision(s_count,:)=squeeze(Con(s_count,t1(1),t2(1),:,6,5));
tRecall(s_count,:)=squeeze(Con(s_count,t1(1),t2(1),:,6,6));
tF1(s_count,:)=squeeze(Con(s_count,t1(1),t2(1),:,6,7));
tPrecisionC(s_count,:)=squeeze(Con(s_count,t1(1),t2(1),:,6,8));
tRecallC(s_count,:)=squeeze(Con(s_count,t1(1),t2(1),:,6,9));
tF1C(s_count,:)=squeeze(Con(s_count,t1(1),t2(1),:,6,10));
er=squeeze(tER(s_count,:));
M_pw(s_count)=mean(er);
V_pw(s_count)=std(er);
end

strf=[Data,num2str(EN),'_LndSpanno_',num2str(nd),'_',ErrT,'_err_pw.mat'];
save(strf,'tER','tPrecision','tRecall','tF1','tPrecisionC','tRecallC','tF1C','Par','M_pw','V_pw');

clear tER tPrecision tRecall tF1 tPrecisionC tRecallC tF1C Par;


end
